//---------------------------------------------------
// module  : f_Restoration.cc                       
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include "Restoration.h"

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------

//------------------------------------------------
// METHODES DE LA CLASSE RESTOR  -----------------
//------------------------------------------------
//----------------------------------------------------------
// Constructeur de la classe Restor
//----------------------------------------------------------
Restor::Restor(int** imgt,int lgth,int wdth)           
 {
  int i,j;

  //Initialisation
  length=lgth;
  width=wdth;

  if (length!=width) 
     { printf("\n Probleme... Non squared Image"); 
       //exit(-1); 
     }

  size_image=length;

  //Allocation memoire matrice
  mat_deg=fmatrix_allocate_2d(length,width);
  mat_img=fmatrix_allocate_2d(length,width);
  mat_rest=fmatrix_allocate_2d(length,width);
  mat_pest=fmatrix_allocate_2d(length,width);
  mat_est=fmatrix_allocate_2d(length,width);
  mat_1est=fmatrix_allocate_2d(length,width);
  mat_rint=fmatrix_allocate_2d(length,width);
  mat_restbest=fmatrix_allocate_2d(length,width);

  mat_psf=fmatrix_allocate_2d(length,width);

  mat_tmp0=fmatrix_allocate_2d(length,width);
  mat_tmp1=fmatrix_allocate_2d(length,width);
  mat_tmp2=fmatrix_allocate_2d(length,width);
  mat_tmp3=fmatrix_allocate_2d(length,width);
  mat_tmp4=fmatrix_allocate_2d(length,width);
  mat_tmp5=fmatrix_allocate_2d(length,width);
  mat_tmp6=fmatrix_allocate_2d(length,width);

  matcg_q=fmatrix_allocate_2d(length,width); 

  //Allocation memoire vecteur
  SumCoefsPAR=fmatrix_allocate_1d(10);
  CoefsGAUSS=fmatrix_allocate_2d(5,5);
  CoefsGAUSS2=fmatrix_allocate_1d(9);

  //Initialisation
  for(i=0;i<length;i++) for(j=0;j<width;j++) 
     mat_img[i][j]=imgt[i][j];

  //Initialisation FLAG/Mesure
  flagR_silent=0;
  isnr=0.0;         isnr_max=0.0;      isnr_stop=0.0;     
  iter_isnr_stop=0; iter_isnr_max=0;  

  //Initialisation Coef GAUSS
  CoefsGAUSS[0][0]=1; CoefsGAUSS[0][1]=4;  CoefsGAUSS[0][2]=6;  CoefsGAUSS[0][3]=4;   CoefsGAUSS[0][4]=1;
  CoefsGAUSS[1][0]=4; CoefsGAUSS[1][1]=16; CoefsGAUSS[1][2]=24; CoefsGAUSS[1][3]=16;  CoefsGAUSS[1][4]=4;  
  CoefsGAUSS[2][0]=6; CoefsGAUSS[2][1]=24; CoefsGAUSS[2][2]=36; CoefsGAUSS[2][3]=24;  CoefsGAUSS[2][4]=6; 
  CoefsGAUSS[3][0]=4; CoefsGAUSS[3][1]=16; CoefsGAUSS[3][2]=24; CoefsGAUSS[3][3]=16;  CoefsGAUSS[3][4]=4; 
  CoefsGAUSS[4][0]=1; CoefsGAUSS[4][1]=4;  CoefsGAUSS[4][2]=6;  CoefsGAUSS[4][3]=4;   CoefsGAUSS[4][4]=1;

  //Initialisation Coef GAUSS2
  CoefsGAUSS2[0]=1;    CoefsGAUSS2[1]=4;   CoefsGAUSS2[2]=10;   CoefsGAUSS2[3]=16;
  CoefsGAUSS2[4]=19;   CoefsGAUSS2[5]=16;  CoefsGAUSS2[6]=10;   CoefsGAUSS2[7]=4;
  CoefsGAUSS2[8]=1;
 }


//----------------------------------------------------------
// Destructeur de la classe Restoration
//----------------------------------------------------------
Restor::~Restor()
{ 
  //Libere Memoire Matrice
  free_fmatrix_2d(mat_deg); 
  free_fmatrix_2d(mat_img);
  free_fmatrix_2d(mat_rest);
  free_fmatrix_2d(mat_pest);
  free_fmatrix_2d(mat_rint);
  free_fmatrix_2d(mat_est);
  free_fmatrix_2d(mat_1est);
  free_fmatrix_2d(mat_restbest);
  
  free_fmatrix_2d(mat_psf);

  free_fmatrix_2d(mat_tmp0);
  free_fmatrix_2d(mat_tmp1); 
  free_fmatrix_2d(mat_tmp2); 
  free_fmatrix_2d(mat_tmp3); 
  free_fmatrix_2d(mat_tmp4); 
  free_fmatrix_2d(mat_tmp5); 
  free_fmatrix_2d(mat_tmp6); 

  free_fmatrix_2d(matcg_q);

  //Libere Memoire Vecteur 
  free_fmatrix_1d(SumCoefsPAR);
  free_fmatrix_2d(CoefsGAUSS);
  free_fmatrix_1d(CoefsGAUSS2);
}

//-----------------//
//--CHOIX METHODE--//
//-----------------//
//----------------------------------------------------------
//  Methode d'Initialisation de restoration                     
//----------------------------------------------------------                
void Restor::restoration(int mtd,int pf,int sz,float vrnoise)
{
 //Initialisation
 //---------------
 method=mtd;
 psf=pf;
 size=sz;
 halfsize=(int)(sz/2);
 variance_noise=vrnoise;
 
 //Information
 //-----------
 if (DEBUG)
   {
    printf("\n -----");
    printf("\n  Psf     [%d]",psf);
    printf("\n  Method  [%d]",method);
    printf("\n     size [%d]",size);
    printf("\n halfsize [%d]",halfsize);
    printf("\n varnoise [%.4f]",variance_noise); 
    printf("\n Lambda   [%.3f]",lambda);
    printf("\n -----");
    printf("\n\n");
   }


 //Degradation
 //-----------
 Degradation(mat_img,mat_deg,variance_noise);

 psnr_observed=computePSNR(mat_img,mat_deg,size_image);
 printf(" >> PSNR :%.2f dB",psnr_observed);
 printf("\n >> SNR  :%.2f dB",computeSNR(mat_deg,variance_noise,size_image));

 CopySquareMatrix(mat_deg,mat_rint,size_image);     
           

 //Methode [matx1est] >> [matx_est] ::Resultat > [mat_rest]
 //------------------------------------------------------------------
 if (method==-1)     CopySquareMatrix(mat_deg,mat_rest,size_image); 

 if (method==0)      UnsupNL_Rest2();
 

 //Mesures [mat_rest]
 //------------------
 isnr=computeISNR(mat_img,mat_deg,mat_rest);
 if (!isnr_stop) isnr_stop=isnr;

 printf("\n");
 printf("\n Resultat Restoration");
 printf("\n --------------------");
 printf("\n ISNR_fine = [%.4f dB]",isnr);
 printf("\n ISNR_stop = [%.4f dB] (%d iters)",isnr_stop,iter_isnr_stop);
 printf("\n ISNR_maxi = [%.4f dB] (%d iters)",isnr_max,iter_isnr_max);
 printf("\n");
}


//------------------------------------//
//------- Unsup. N-L Rest2 -----------//
//------------------------------------//
//----------------------------------------------------------
//
//  ISNR Result
//               ISNR_stop = [7.8127 dB] 
//               ISNR_stop = [7.1412 dB] 
//               ISNR_stop = [5.2401 dB] 
//               ISNR_stop = [3.8292 dB] 
//               ISNR_stop = [4.2450 dB] 
//               ISNR_stop = [2.9922 dB] 
//             
//----------------------------------------------------------     
void Restor::UnsupNL_Rest2()
{
 int k,l;
 int flag_stop;
 float map_current;
 float map_previous;
 float likelihoodmmse;
 float map_stab;
 float fon_stab;
 float nrj_prior;
 float nrj_prior2;

 float lambda_0,lambda_1,lambda_2;
 float logfx,logfxp,logx,logxp;
 float tmp1,tmp2;
 float signe;
 int   flag_signe;
 float SigmaGraphe;

 //Init values
 flag_signe=0;
 nrj_prior2=0.0;
 likelihoodmmse=0.0;

 //Init matx_Est & NRJ initiale
   { printf("\n    (> Init:ImgDegrad)");
      CopySquareMatrix(mat_deg,mat_1est,size_image); 
      CopySquareMatrix(mat_1est,mat_est,size_image); }

 //Init NRJ initiale
 isnr=computeISNR(mat_img,mat_deg,mat_est);
 if (isnr>isnr_max) isnr_max=isnr;
 printf(" >>[ISNR = %.3f]\n",isnr);
 fflush(stdout);

 //Initialisation
 flag_stop=0;
 map_current=0;
 isnr=0.0; 
 isnr_max=0.0; 
 isnr_stop=0.0;
 iter_isnr_stop=0;
 iter_isnr_max=0;

 //Init objet & A priori BUADES SPATIAL
 BuadesPrior* bdp=new BuadesPrior(length,width,SIZEW,7,10*sqrt(variance_noise),0.75);          
 (*bdp).FlgSilent=1; 
 (*bdp).ComputePrior(mat_deg); 

 //NbIteration
 if (variance_noise<1) nbiter=(int)(300.0/variance_noise);     
 else  nbiter=MIN(100,(int)(300.0/sqrt(variance_noise)));                   

 //Presentation
 printf("\n     -----------------------------------------------"); 
 printf("\n       LandWeber & Busades <Unsupervised> 2 Passes  ");
 printf("\n     -----------------------------------------------");
 printf("\n        (> -m [%d]",method);
 printf("\n        (> PSF: [%d]  SizePsf: [[Half*2]+1] %d = %d [Size])",psf,(halfsize*2)+1,size); 
 printf("\n        (> VarianceNoise: [%.2f])",variance_noise);
 printf("\n        (> SizeImage: [%d])",size_image);
 printf("\n        -----------------");
 printf("\n        (> Gamma  : [%.4f])",lambda);
 printf("\n        (> Tau    : [%.4f])",Tau);
 printf("\n        -----------------"); 
 printf("\n        (> NbIter  : Automatic> [%d])",nbiter);  
 printf("\n        -----------------"); 
 printf("\n");

 //-----------------------------------------------------------
 // Estimation
 //----------------------------------------------------------- 

 lambda_0=sqrt(variance_noise)/12;

 printf("\n"); 
 printf("\n lambda=[%.4f] (%d)",lambda_0,(int)(50/sqrt(variance_noise)));  
 printf("\n\n");   
 for(k=1;k<(50/sqrt(variance_noise));k++)
    {
     //Gestion
     CopySquareMatrix(mat_est,mat_pest,size_image); 

     //IterationLandWeber[mat_est]
     GradientIterLandweber();  
     (*bdp).Denoising(mat_pest,mat_1est);                      
     SubstractSquareMatrix(mat_tmp0,mat_pest,mat_1est,size_image);
     FabsPowMatrix(mat_tmp0,size_image,Tau);
     nrj_prior2=ComputeNorm2(mat_tmp0,size_image,size_image)*(size_image*size_image);
     AddSquareMatrix(mat_est,1.0,mat_est,lambda_0*(Tau+1)*-1.0,mat_tmp0,size_image); 
       
     //Mesures[mat_est]
     isnr=computeISNR(mat_img,mat_deg,mat_est);
     likelihoodmmse=ComputeLikelihoodMMSE(mat_est,mat_deg,size_image);             
     printf("\n [%d>ISNR = %.4f]",k,isnr);
     printf(" [NrjML = %.3f]",likelihoodmmse);
     printf(" [NrjPr = %.4f]",nrj_prior2);   
     fflush(stdout);
    }  

   logfx=log(nrj_prior2);
   logx=log(likelihoodmmse);
   printf("\n\n >>[ log x : %.3f || log y : %.3f ]",logx,logfx);
   printf("\n\n        (> Init:ImgDegrad)\n\n");
   CopySquareMatrix(mat_deg,mat_1est,size_image); 
   CopySquareMatrix(mat_1est,mat_est,size_image); 

   lambda_1=sqrt(variance_noise)/8;
  
   printf("\n"); 
   printf("\n lambda=[%.4f] (%d)",lambda_1,(int)(50/sqrt(variance_noise)));  
   printf("\n\n");
  for(k=1;k<(50/sqrt(variance_noise));k++)
    {
     //Gestion
     CopySquareMatrix(mat_est,mat_pest,size_image); 

     //IterationLandWeber[mat_est]
     GradientIterLandweber();  
     (*bdp).Denoising(mat_pest,mat_1est);                      
     SubstractSquareMatrix(mat_tmp0,mat_pest,mat_1est,size_image);
     FabsPowMatrix(mat_tmp0,size_image,Tau);
     nrj_prior2=ComputeNorm2(mat_tmp0,size_image,size_image)*(size_image*size_image);
     AddSquareMatrix(mat_est,1.0,mat_est,lambda_1*(Tau+1)*-1.0,mat_tmp0,size_image); 
       
     //Mesures[mat_est]
     isnr=computeISNR(mat_img,mat_deg,mat_est);
     likelihoodmmse=ComputeLikelihoodMMSE(mat_est,mat_deg,size_image);             
     printf("\n [%d>ISNR = %.4f]",k,isnr);
     printf(" [NrjML = %.3f]",likelihoodmmse);
     printf(" [NrjPr = %.4f]",nrj_prior2);   
     fflush(stdout);
    }  

    logfxp=log(nrj_prior2);
    logxp=log(likelihoodmmse);
    printf("\n\n >>[ log xp : %.3f || log yp : %.3f ]\n\n",logxp,logfxp);
    tmp1=((logfxp - logfx)/(logxp-logx));
    tmp2=(logfx)/tmp1;
    lambda_2=lambda_0-Signe(tmp2)*0.1;
    printf("  >Increment [%.3f][>>lambda=%.3f]",-Signe(tmp2)*0.1,lambda_2);
    lambda_1=lambda_2;
    printf("\n  >[lambda_0=%.3f][lambda_1=%.3f]",lambda_0,lambda_1);
    logfx=logfxp;
    logx=logxp;
    signe=(int)Signe(tmp2);
    printf("\n\n        (> Init:ImgDegrad)\n\n");
    CopySquareMatrix(mat_deg,mat_1est,size_image); 
    CopySquareMatrix(mat_1est,mat_est,size_image); 
 

 //-----------------------------------------------------------
 // Boucle LandWeber + Contrainte Buades NRJ
 //-----------------------------------------------------------        
  for(l=0;;l++) 
    {         
      if (flag_signe)
	{ lambda_1*=0.4; //0.5
          printf("\n >>> DERNIERE [gamma=[%.3f]]",lambda_1); }
              
      for(k=1;k<(((50/sqrt(variance_noise))*(1-flag_signe))+(flag_signe*nbiter));k++)
         {
          //Gestion
          CopySquareMatrix(mat_est,mat_pest,size_image); 

          //IterationLandWeber[mat_est]
          GradientIterLandweber(); 
  
          (*bdp).Denoising(mat_pest,mat_1est);                  
          nrj_prior=ComputeNorm2(mat_pest,mat_1est,size_image,size_image); 
    
          SubstractSquareMatrix(mat_tmp0,mat_pest,mat_1est,size_image);
          FabsPowMatrix(mat_tmp0,size_image,Tau);
          nrj_prior2=ComputeNorm2(mat_tmp0,size_image,size_image)*(size_image*size_image);
          AddSquareMatrix(mat_est,1.0,mat_est,(lambda_1*(Tau+1)*-1.0),mat_tmp0,size_image); 
      
         //Mesures[mat_est]
          map_previous=map_current; 
          isnr=computeISNR(mat_img,mat_deg,mat_est);
          likelihoodmmse=ComputeLikelihoodMMSE(mat_est,mat_deg,size_image);
          map_current=likelihoodmmse;             
          map_stab=fabs((map_current-map_previous)/(map_current));
          fon_stab=computeSTAB(mat_est,mat_pest,size_image);
 
          printf("\n [%d>ISNR = %.4f]",k,isnr);
          printf(" [NrjML = %.3f]",likelihoodmmse);
          printf(" [NrjPr = %.4f]",nrj_prior2);   
          printf(" [[Alpha=%.3f]]",(likelihoodmmse/nrj_prior2)); 
          printf(" <stab=%.3f>",fon_stab*1000000); 
          fflush(stdout);

          //BEST
          if (isnr>isnr_max) 
             { isnr_max=isnr; 
               iter_isnr_max=k; 
               CopySquareMatrix(mat_est,mat_restbest,size_image); }
         }

      //Calcul Gamma
    if (flag_signe) break;
    logfxp=log(nrj_prior2);
    logxp=log(likelihoodmmse);
    printf("\n\n >>[ log xp : %.3f || log yp : %.3f ]\n\n",logxp,logfxp); 
    tmp1=((logfxp - logfx)/(logxp-logx));
    tmp2=(logfx)/tmp1;
    lambda_2=lambda_1-Signe(tmp2)*0.1;
    if (signe!=(int)Signe(tmp2)) { flag_signe=1; printf("*"); }
    printf("  >Increment [%.3f][>>lambda=%.3f]",-Signe(tmp2)*0.1,lambda_2);
    printf("\n  >[lambda_1=%.3f][lambda_2=%.3f]",lambda_1,lambda_2);
    lambda_1=lambda_2;
    logfx=logfxp;
    logx=logxp;
    printf("\n\n        (> Init:ImgDegrad)\n\n");
    CopySquareMatrix(mat_deg,mat_1est,size_image); 
    CopySquareMatrix(mat_1est,mat_est,size_image); 

    }
 //--------------------------------------------------------


 //---------------------------------------------------------------------
 //       2ieme Passes -------------------------------------------------
 //---------------------------------------------------------------------

 //Presentation
 printf("\n     --------------------------------------"); 
 printf("\n      2ieme Pass Graph <1/3 pixel>         ");
 printf("\n     --------------------------------------");

 //Window Size 2nd graph
 int Szw;
 if (variance_noise<20) Szw=1;
 else                   Szw=3;

 //Init objet & A priori
 printf("\n  Compute Graph ... [%d pixel]",Szw);
 if (variance_noise<5) SigmaGraphe=10*sqrt(variance_noise);
 else SigmaGraphe=5*sqrt(variance_noise);
 BuadesPrior* bdp2=new BuadesPrior(length,width,Szw,7,SigmaGraphe,8.0);  
 (*bdp2).ComputePrior(mat_est); 
 (*bdp2).FlgSilent=1;
 printf("...");
 fflush(stdout);

  //Initialisation
 flag_stop=0;
 map_current=0;
 isnr=0.0; 
 isnr_max=0.0; 
 isnr_stop=0.0;
 iter_isnr_stop=0;
 iter_isnr_max=0;
 nrj_prior=0.0;

 if ((variance_noise)<40) lambda_1=sqrt(variance_noise)/12;
 else lambda_1=sqrt(variance_noise)/6;

 //Init matx_Est & NRJ initiale
 printf("\n        (> Init:ImgDegrad)");
 CopySquareMatrix(mat_deg,mat_1est,size_image); 
 CopySquareMatrix(mat_1est,mat_est,size_image); 

 //Init NRJ initiale
 isnr=computeISNR(mat_img,mat_deg,mat_est);
 if (isnr>isnr_max) isnr_max=isnr;
 printf(" >>>[ISNR = %.4f]\n",isnr);
 fflush(stdout);

 //Info
 printf("\n        (> Lambda       : [%.4f])",lambda_1);
 printf("\n        (> Tau          : [%.4f])",Tau);
 printf("\n        (> Szw          : [%d])",Szw);
 printf("\n");
 fflush(stdout);
 
  //-----------------------------------------------------------
 // Boucle LandWeber + Contrainte Buades NRJ
 //-----------------------------------------------------------                                 
 for(k=1;(k<1.2*nbiter);k++)
    {
     //Gestion
     CopySquareMatrix(mat_est,mat_pest,size_image); 

     //IterationLandWeber[mat_est]
     GradientIterLandweber();  

     //ContraintesBuades[mat_est]
     (*bdp2).Denoising(mat_pest,mat_1est);
     SubstractSquareMatrix(mat_tmp0,mat_pest,mat_1est,size_image);
     FabsPowMatrix(mat_tmp0,size_image,Tau);
     nrj_prior=ComputeNorm2(mat_tmp0,size_image,size_image)*(size_image*size_image);
     AddSquareMatrix(mat_est,1.0,mat_est,(lambda_1*(Tau+1)*-1.0),mat_tmp0,size_image); //
     ConstraintMaxMin(mat_est,size_image);
   
     //Mesures[mat_est]
     map_previous=map_current; 
     isnr=computeISNR(mat_img,mat_deg,mat_est);
     likelihoodmmse=ComputeLikelihoodMMSE(mat_est,mat_deg,size_image);
     map_current=likelihoodmmse;  
              
     map_stab=fabs((map_current-map_previous)/(map_current));
     fon_stab=computeSTAB(mat_est,mat_pest,size_image);

     printf("\n [%d>ISNR = %.4f]",k,isnr);
     printf(" [NrjML = %.1f]",map_current);
     printf(" [NrjPr = %.2f]",nrj_prior);   
     printf(" [%.6f < %.6f]",map_stab*MILLE,(ARRETMAP*variance_noise)*MILLE);
     printf(" [[%.6f]]",fon_stab*MILLIONS);
     fflush(stdout);

     //BEST
     if (isnr>isnr_max) 
        { isnr_max=isnr; 
          iter_isnr_max=k; 
          CopySquareMatrix(mat_est,mat_restbest,size_image); }
    }
 //--------------------------------------------------------


  //Record
  isnr_stop=isnr;
  iter_isnr_stop=k-1; 
  lambda=lambda_1;

  //Copiage Resultat Final > mat_rest
  CopySquareMatrix(mat_est,mat_rest,size_image); 
  

  //NRJ-MAP/ML
  printf("\n\n Energie ML : %.4f\n",ComputeLikelihoodMMSE(mat_est,mat_deg,size_image));

  //Delete Objet
   if (bdp) delete (bdp);
   if (bdp2) delete (bdp2);
}

//-----------//
//--OPTIONS--//
//-----------//
//----------------------------------------------------------
// Options                  
//----------------------------------------------------------                
void Restor::option(int nit,int sv,float lbd,char* ch,float ta)
{
 int i,k,l;
 float sum;

 //Calcul Somme Coefs PAR
 for(i=1;i<10;i++)
    {  sum=0.0;
      for(k=-i;k<=i;k++) for(l=-i;l<=i;l++)
          sum+=1.0/(1+CARRE(k)+CARRE(l));

      SumCoefsPAR[i]=sum;  }
 
 if (DEBUG)
    {
     printf("\n Somme Coefs PAR >");
     for(i=1;i<8;i++) printf(" [%.3f]",SumCoefsPAR[i]);
     printf("\n");  
    }  

 //Enregistrement
 nbiter=nit;
 flag_save=sv;
 strcpy(Name_Img,ch);
 lambda=lbd;
 Tau=ta;
}

//----------------------//
//----------------------//
//--GRADIENT-LANDWEBER--//
//----------------------//
//----------------------//
//----------------------------------------------------------
//  BoucleLandweber
//  
//      > Init:ImgDegrad) > LandWeber   
//----------------------------------------------------------     
void Restor::BoucleLandweber()
{
 int k;
 int flag;
 float mmse_current;
 float mmse;
 
 //Initialisation
 flag=0;
 k=0;


      //Presentation
       printf("\n     -------------------"); 
       printf("\n      LandWeber         ");
       printf("\n     -------------------");
       printf("\n        (> NbIter: %d)",nbiter);
       printf("\n        (> PSF: %d  SizePsf: %d)",psf,(halfsize*2)+1); 
       printf("\n        (> VarianceNoise: %.2f)",variance_noise);
       printf("\n");   
        
      //BOUCLE            
     for(k=1;((k<nbiter)&&(!flag));k++)
        {
         //h(x,y)*fk(x,y) > mat_tmp3
         ConvolutionSquareMatrixWithPsf(mat_tmp3,mat_est,size_image);

         //g(x,y)-h(x,y)*fk(x,y) > mat_tmp4
         SubstractSquareMatrix(mat_tmp4,mat_deg,mat_tmp3,size_image);

         //h(x,y)*[g(x,y)-h(x,y)*fk(x,y)] > mat_tmp5
         ConvolutionSquareMatrixWithPsf(mat_tmp5,mat_tmp4,size_image);

         //fk(x,y)+ [...]
         AddSquareMatrix(mat_est,mat_est,mat_tmp5,size_image);

         //ContrainteMinMax
         ConstraintMaxMin(mat_est,size_image);
   
         //ISNR : NRJ [mat_est]
         mmse_current=mmse;
         isnr=computeISNR(mat_img,mat_deg,mat_est);
         mmse=computeMMSE(mat_pest,mat_est,size_image);
         CopySquareMatrix(mat_est,mat_pest,size_image);  
         printf("\n [%d>ISNR = %.4f] [MMSE = %.4f]",k,isnr,MILLIONS*mmse);
         fflush(stdout);
        }

     //Espace
     printf("\n");
}


//----------------------------------------------------------
//  GradientIterLandweber
//
//  mat_est=GradientLandWeber(mat_est) 
//
//  float** matcg_q;
//
// x[k]=x[k-1]+A*(y-Ax[k])
//  
//----------------------------------------------------------     
void Restor::GradientIterLandweber()
{
 float Alpha;

  //Iteration  Gradient
  //-------------------

       //h(x,y)*x[k] > mat_tmp3
       ConvolutionSquareMatrixWithPsf(mat_tmp3,mat_est,size_image);

       //g(x,y)-h(x,y)*fk(x,y) > mat_tmp4
       SubstractSquareMatrix(mat_tmp4,mat_deg,mat_tmp3,size_image);

       //h(x,y)*[g(x,y)-h(x,y)*fk(x,y)] > matcg_q
       ConvolutionSquareMatrixWithPsf(matcg_q,mat_tmp4,size_image);

       //A*q[k]
       ConvolutionSquareMatrixWithPsf(mat_tmp5,matcg_q,size_image);

       //Alpha[k] = ||q[k]||^2 / ||mat_tmp5||^2
       Alpha=DivNorm(matcg_q,mat_tmp5,size_image);
       printf("{%.3f}",Alpha); 
       
       //x[k]=x[k-1]+alpha[k].q[k]
       AddSquareMatrix(mat_est,mat_est,matcg_q,size_image,Alpha);

 //ContrainteMinMax
 ConstraintMaxMin(mat_est,size_image);
}

//------------------------//
//-----DEGRADATIONS-------//
//------------------------//
//----------------------------------------------------------
// Degradation    
//                   Utilise 
//                           mat_tmp0
//                           mat_tmp1
//----------------------------------------------------------                
void Restor::Degradation(float** mtin,float** mtout,float vn)
{
  int i,j,k,l,m,n;
  float sum,sumcoef,coef;
  float tmp,moy;
  float varv;

  //Presentation
  //------------
  printf("\n      DEGRADATION ");
  printf("\n      ----------- ");
  printf("\n    [PSF=%d]",psf);

  //Init
  copy_matrix(mat_tmp1,mtin,length,width);

  //Debug
  //for(i=0;i<length;i++) for(j=0;j<width;j++)
  //  printf("[%.0f]",mtin[i][j]);
  //exit(-1);
 
  //Convolution FLOU
  //----------------
 //--0eme PSF--
 if (psf==0) 
    for(i=0;i<length;i++) for(j=0;j<width;j++)  mtout[i][j]=mtin[i][j]; 
 
 //--1eme PSF--
 if (psf==1)
  {
    for(i=0;i<length;i++) for(j=0;j<width;j++) 
     {
      sum=0.0;
      for(k=-halfsize;k<=halfsize;k++) for(l=-halfsize;l<=halfsize;l++)
         {
           m=0;
	   if ((i+k)<0)            m=length;
           if ((i+k)>(length-1))   m=-length;

           n=0;
           if ((j+l)<0)            n=width;
           if ((j+l)>(width-1))    n=-width;

           sum+=mtin[i+k+m][j+l+n];
         }
      sum/=(CARRE(size));
      mtout[i][j]=sum;
     }
  }


 //--2eme PSF-- 
 if (psf==2)
    {
       for(i=0;i<length;i++) for(j=0;j<width;j++) 
          {
	   sum=0.0; sumcoef=0.0;
           for(k=-halfsize;k<=halfsize;k++) for(l=-halfsize;l<=halfsize;l++)
              {
               m=0;
	       if ((i+k)<0)            m=length;
               if ((i+k)>(length-1))   m=-length;

               n=0;
               if ((j+l)<0)            n=width;
               if ((j+l)>(width-1))    n=-width;
                    
               coef=1.0/(1+CARRE(k)+CARRE(l));
               sumcoef+=coef;
               sum+=coef*mtin[i+k+m][j+l+n];
              }
           sum/=sumcoef;
           mtout[i][j]=sum;
          } 
     }


 //--3eme PSF-- 
 if (psf==3)
    {
     for(i=0;i<length;i++) for(j=0;j<width;j++) 
        {
         sum=0.0; sumcoef=0.0;
           for(k=-halfsize;k<=halfsize;k++) for(l=-halfsize;l<=halfsize;l++)
               {
                m=0;
	        if ((i+k)<0)            m=length;
                if ((i+k)>(length-1))   m=-length;

                n=0;
                if ((j+l)<0)            n=width;
                if ((j+l)>(width-1))    n=-width;
                   
                sumcoef+=CoefsGAUSS[k+2][l+2];
                sum+=CoefsGAUSS[k+2][l+2]*mtin[i+k+m][j+l+n];
               }
           sum/=sumcoef;
           mtout[i][j]=sum;
        }    
    }

 //--4eme PSF-- 
  if (psf==4)
    {
     for(i=0;i<length;i++) for(j=0;j<width;j++) 
        {
         sum=0.0; 
         for(l=-4;l<=4;l++)
            {
             n=0;
             if ((j+l)<0)            n=width;
             if ((j+l)>(width-1))    n=-width;
             sum+=CoefsGAUSS2[l+4]*mtin[i][j+l+n];
             }
           sum/=81.0;
           mtout[i][j]=sum;
        }  


      for(i=0;i<length;i++) for(j=0;j<width;j++) 
        {
         sum=0.0; 
         for(k=-4;k<=4;k++)
            {
             m=0;
	     if ((i+k)<0)            m=length;
             if ((i+k)>(length-1))   m=-length;
             sum+=CoefsGAUSS2[k+4]*mtout[i+k+m][j];
               }
           sum/=81.0;
           mat_tmp0[i][j]=sum;
         }
     for(i=0;i<length;i++) for(j=0;j<width;j++) mtout[i][j]=mat_tmp0[i][j];
    }   

  //--5eme PSF-- 
  if (psf==5)
    {
       for(i=0;i<length;i++) for(j=0;j<width;j++) 
          {
	   sum=0.0; sumcoef=0.0;
           for(k=-halfsize;k<=halfsize;k++) for(l=-halfsize;l<=halfsize;l++)
              {
               m=0;
	       if ((i+k)<0)            m=length;
               if ((i+k)>(length-1))   m=-length;

               n=0;
               if ((j+l)<0)            n=width;
               if ((j+l)>(width-1))    n=-width;
                    
               coef=pow((1+((CARRE(k)+CARRE(l))/16)),-3);
               sumcoef+=coef;
               sum+=coef*mtin[i+k+m][j+l+n];
              }
           sum/=sumcoef;
           mtout[i][j]=(int)sum;
          } 
     } 

 //Pour BSNR
 tmp=0.0;
 moy=0.0;
 for(i=0;i<length;i++) for(j=0;j<width;j++) moy+=mtout[i][j];
 moy/=(length*width);
 for(i=0;i<length;i++) for(j=0;j<width;j++) tmp+=CARRE(mtout[i][j]-moy);

 //Ajout BRUIT
 //-----------
 add_gaussian_noise(mtout,length,width,vn);
    
  for(i=0;i<length;i++) for(j=0;j<width;j++) 
   { if (mtout[i][j]>255) {  mtout[i][j]=255; printf("*"); }
     if (mtout[i][j]<0)   {  mtout[i][j]=0;   printf("*"); } }

 //Verif
 varv=computeMMSE(mat_tmp1,mtout,size_image);
 printf("\n >> MMSE :%.3f",varv);

 //Pour BSNR
 tmp/=((length*width)*vn);
 bsnr_observed=10*log10(tmp);
 printf("\n >> BSNR :%.2f dB\n",bsnr_observed);
}


//-----------//
//--MESURES--//
//-----------//
//----------------------------------------------------------       
// ComputeLikelihoodMMSE
//----------------------------------------------------------                
float Restor::ComputeLikelihoodMMSE(float** mt1,float** mt2,int sz)
{
 int i,j;
 float sum;
 float likelihoodmmse;

 //Flou
 ConvolutionSquareMatrixWithPsf(mat_tmp6,mt1,sz);

//Boucle 
 sum=0.0;
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) 
    sum+=CARRE(mt2[i][j]-mat_tmp6[i][j]);

 //MMSE
 likelihoodmmse=sum;
 //printf("  [>>>%f]",sum);

 //retour
 return likelihoodmmse;
}

//----------------------------------------------------------
// Compute ISNR                
//----------------------------------------------------------     
float Restor::computeISNR(float** matimg,float** matdeg,float** matrest)
{
 int i,j;
 float num,den;
 float isnr;

 //Boucle
 num=0.0; den=0.0; 
 for(i=0;i<length;i++) for(j=0;j<width;j++) num+=CARRE(matimg[i][j]-matdeg[i][j]);
 for(i=0;i<length;i++) for(j=0;j<width;j++) den+=CARRE(matimg[i][j]-matrest[i][j]);

 //ISNR
 isnr=10*log10(num/den);

 //retour
 return isnr;
}

//----------------------------------------------------------
// MMSE               
//----------------------------------------------------------     
float Restor::computeMMSE(float** mat1,float** mat2,int sz)
{
 int i,j;
 float sum;
 float mmse;

 //MMSE 
 sum=0.0;
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) 
    sum+=CARRE(mat2[i][j]-mat1[i][j]);

 mmse=(sum/CARRE(sz));

 //retour
 return mmse;
}


//----------------------------------------------------------
// Compute PSNR                
//----------------------------------------------------------     
float Restor::computePSNR(float** matimg,float** matdeg,int sz)
{
 int i,j;
 float num,den;
 float psnr;

 //Boucle
 num=255.0;

 den=0.0;
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) den+=CARRE(matimg[i][j]-matdeg[i][j]);
 den=sqrt(den)/sz;

 //PSNR
 psnr=20*log10(num/den);

 //retour
 return psnr;
}

//----------------------------------------------------------
// Compute SNR                
//----------------------------------------------------------     
float Restor::computeSNR(float** mte,float vr,int sz)
{
 int i,j;
 float vari,moyi;
 float snr;

 //Image
 vari=0.0;
 moyi=0.0;
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) moyi+=mte[i][j];
 moyi/=(sz*sz);
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) vari+=CARRE(mte[i][j]-moyi);
 vari/=(sz*sz);
 printf("  (MoyImg [%.4f]   VarImg [%.4f])",moyi,vari);
 
 //SNR
 snr=10*log10(vari/vr);

 //retour
 return snr;
}

//----------------------------------------------------------
// STAB              
//----------------------------------------------------------     
float Restor::computeSTAB(float** mat,float** matp,int sz)
{
 int i,j;
 float sum;
 float den;
 float stab;

 //STAB
 sum=0.0;
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) sum+=CARRE(mat[i][j]-matp[i][j]);

 den=0.0;
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) den+=CARRE(mat[i][j]);

 stab=(sum/den);

 //retour
 return stab;
}


//-----------//
//--GESTION--//
//-----------//
//----------------------------------------------------------
// ConvolutionSquareMatrix
//----------------------------------------------------------
void Restor::ConvolutionSquareMatrixWithPsf(float** matfres,float** matf,int sz)
{
 int i,j,k,l,m,n;
 float sum,sumcoef,coef;
 float nb; 

  //Convolution
  //-----------
  //--0ere PSF-- 
 if (psf==0)
    for(i=0;i<sz;i++) for(j=0;j<sz;j++) matfres[i][j]=matf[i][j];

 //--1ere PSF--  
 if (psf==1)
    {
       for(i=0;i<sz;i++) for(j=0;j<sz;j++) 
           {
	    sum=0.0; nb=0.0;
            for(k=-halfsize;k<=halfsize;k++) for(l=-halfsize;l<=halfsize;l++)
               {
                m=0;
	        if ((i+k)<0)            m=length;
                if ((i+k)>(length-1))   m=-length;

                n=0;
                if ((j+l)<0)            n=width;
                if ((j+l)>(width-1))    n=-width;

                sum+=matf[i+k+m][j+l+n];   
               }
             sum/=(CARRE(size));
             matfres[i][j]=sum;
          }
    }

 //--2eme PSF-- 
 if (psf==2)
    {
       for(i=0;i<sz;i++) for(j=0;j<sz;j++) 
          {
	   sum=0.0; sumcoef=0.0;
           for(k=-halfsize;k<=halfsize;k++) for(l=-halfsize;l<=halfsize;l++)
	      {
                m=0;
	        if ((i+k)<0)             m=length;
                if ((i+k)>(length-1))    m=-length;

                n=0;
                if ((j+l)<0)             n=width;
                if ((j+l)>(width-1))     n=-width;

                coef=1.0/(1+CARRE(k)+CARRE(l));
                sumcoef+=coef;
                sum+=coef*matf[i+k+m][j+l+n];
              }
           sum/=sumcoef;
           matfres[i][j]=sum;
          } 
     }


 //--3eme PSF-- 
 if (psf==3)
    {
     for(i=0;i<sz;i++) for(j=0;j<sz;j++) 
        {
         sum=0.0; sumcoef=0.0;
           for(k=-halfsize;k<=halfsize;k++) for(l=-halfsize;l<=halfsize;l++)
               {
                m=0;
	        if ((i+k)<0)            m=length;
                if ((i+k)>(length-1))   m=-length;

                n=0;
                if ((j+l)<0)            n=width;
                if ((j+l)>(width-1))    n=-width;
              
                sumcoef+=CoefsGAUSS[k+2][l+2];
                sum+=CoefsGAUSS[k+2][l+2]*matf[i+k+m][j+l+n];
               }
           sum/=sumcoef;
           matfres[i][j]=sum;
        }    
    }
 
 //--4eme PSF-- 
  if (psf==4)
    {
     for(i=0;i<length;i++) for(j=0;j<width;j++) 
        {
         sum=0.0; 
         for(l=-4;l<=4;l++)
            {
             n=0;
             if ((j+l)<0)            n=width;
             if ((j+l)>(width-1))    n=-width;
             sum+=CoefsGAUSS2[l+4]*matf[i][j+l+n];
             }
           sum/=81.0;
           mat_tmp0[i][j]=sum;
        }  


      for(i=0;i<length;i++) for(j=0;j<width;j++) 
        {
         sum=0.0; 
         for(k=-4;k<=4;k++)
            {
             m=0;
	     if ((i+k)<0)            m=length;
             if ((i+k)>(length-1))   m=-length;
             sum+=CoefsGAUSS2[k+4]*mat_tmp0[i+k+m][j];
             }
           sum/=81.0;
           mat_tmp0[i][j]=sum;
         }

    for(i=0;i<length;i++) for(j=0;j<width;j++) matfres[i][j]=mat_tmp0[i][j];
    } 
  
  //--5eme PSF-- 
  if (psf==5)
    {
       for(i=0;i<length;i++) for(j=0;j<width;j++) 
          {
	   sum=0.0; sumcoef=0.0;
           for(k=-halfsize;k<=halfsize;k++) for(l=-halfsize;l<=halfsize;l++)
              {
               m=0;
	       if ((i+k)<0)            m=length;
               if ((i+k)>(length-1))   m=-length;

               n=0;
               if ((j+l)<0)            n=width;
               if ((j+l)>(width-1))    n=-width;
                    
               coef=pow((1+((CARRE(k)+CARRE(l))/16)),-3);
               sumcoef+=coef;
               sum+=coef*matf[i+k+m][j+l+n];
              }
           sum/=sumcoef;
           matfres[i][j]=(int)sum;
          } 
     } 
}

//----------------------------------------------------------
// SubstractSquareMatrix
//----------------------------------------------------------
void Restor::SubstractSquareMatrix(float** matfres,float** mat1,float** mat2,int sz)
{
 int i,j;

 //Boucle
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)  matfres[i][j]=mat1[i][j]-mat2[i][j]; 
}

//----------------------------------------------------------
// AddSquareMatrix
//----------------------------------------------------------
void Restor::AddSquareMatrix(float** matfres,float** mat1,float** mat2,int sz)
{
 int i,j;

 //Boucle
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)  matfres[i][j]=mat1[i][j]+mat2[i][j]; 
}

//----------------------------------------------------------
// AddSquareMatrix
//----------------------------------------------------------
void Restor::AddSquareMatrix(float** matfres,float** mat1,float** mat2,int sz,float coef)
{
 int i,j;

 //Boucle
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)  matfres[i][j]=mat1[i][j]+coef*mat2[i][j]; 
}

//----------------------------------------------------------
// AddSquareMatrix
//----------------------------------------------------------
void Restor::AddSquareMatrix(float** matfres,float coef1,float** mat1,float coef2,float** mat2,int sz)
{
 int i,j;

 //Boucle
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)  matfres[i][j]=coef1*mat1[i][j]+coef2*mat2[i][j]; 
}

//----------------------------------------------------------
// MultSquareMatrix
//----------------------------------------------------------
void Restor::MultSquareMatrix(float** matfres,float** mat1,float** mat2,int sz)
{
 int i,j;

 //Boucle
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)  matfres[i][j]=mat1[i][j]*mat2[i][j]; 
}

//----------------------------------------------------------
// FabsPowMatrix
//----------------------------------------------------------
void Restor::FabsPowMatrix(float** mat,int sz,float exp)
{
 int i,j;
 float signe;

 //Boucle
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)  
   { signe=mat[i][j];
     if (signe>0) signe=1.0;
     else         signe=-1.0;
     mat[i][j]=powf(fabs(mat[i][j]),exp);
     mat[i][j]*=(signe); }
}

//----------------------------------------------------------       
// ConstraintMaxMin 
//----------------------------------------------------------                
void Restor::ConstraintMaxMin(float** mt,int sz)
{
 int i,j;

 //Boucle
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)
    {
     if (mt[i][j]>255.0)  mt[i][j]=255.0;
     if (mt[i][j]<0.0)    mt[i][j]=0.0; 
    } 
}

//----------------------------------------------------------
// MeanSqWindow             
//----------------------------------------------------------     
float Restor::MeanSqWindow(float** mat,int sz)
{
 int i,j;
 float mean=0.0;

 for(i=0;i<sz;i++) for(j=0;j<sz;j++)
   mean+=mat[i][j];

 mean/=(CARRE(sz));

 return mean;
}


//----------------------------------------------------------
// DivNorm     
//----------------------------------------------------------     
float Restor::DivNorm(float** mat,float** matd,int sz)
{
 int i,j;
 float sum1=0.0;
 float sum2=0.0;
 float rap;

 for(i=0;i<sz;i++) for(j=0;j<sz;j++)   sum1+=CARRE(mat[i][j]);
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)   sum2+=CARRE(matd[i][j]);

 if (sum2)    rap=sum1/sum2;
 else         rap=1.0;

 return rap;
}

//-------------//
//--FILE-------//
//-------------//
//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format pgm                        
//----------------------------------------------------------                
void Restor::saveImagePgm(char* name,float** mat,int lgth,int wdth)
{
 int i,j;
 char buff[300];
 FILE* fic;

  //--extension--
  strcpy(buff,name);
  strcat(buff,".pgm");

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
  printf("\n Sauvegarde de %s au format pgm\n",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",lgth,wdth);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
	fprintf(fic,"%c",(char)mat[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 
}

