//------------------------------------------------------
// module  : function.h
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <new>

//------------------------------------------------
// CONSTANTES & DEFINITIONS ----------------------
//------------------------------------------------
#define CARRE(X) ((X)*(X))
#define PI  3.14159
#define GREY_LEVEL 255

#define SWAP(a,b) temp=(a);(a)=(b);(b)=temp;
#define SIGN(a,b)  ((b) >= 0.0 ? fabs(a): -fabs(a))
#define MAX(a,b)   (((a)>(b))?(a):(b))
#define MIN(a,b)   (((a)>(b))?(b):(a))
#define SQUARE(a)  ((a)*(a))

//------------------------------------------------
// PROTOTYPE -------------------------------------
//------------------------------------------------

//--->Matrix
float*    fmatrix_allocate_1d(int);
float**   fmatrix_allocate_2d(int,int);
float***  fmatrix_allocate_3d(int,int,int);
int*      imatrix_allocate_1d(int);
int**     imatrix_allocate_2d(int,int);
int***    imatrix_allocate_3d(int,int,int);

void  free_fmatrix_1d(float*);
void  free_fmatrix_2d(float**);
void  free_fmatrix_3d(float***,int);
void  free_imatrix_1d(int*);
void  free_imatrix_2d(int**);
void  free_imatrix_3d(int***,int);

//--->Bruit
float  gaussian_noise(float,float);
void   add_gaussian_noise(float**,int,int,float);

//--->Load/Save File
void GetLengthWidth(char*,int*,int*);
void load_image_pgm(char*,int**,int,int);
void SaveImagePgm(char*,char*,float**,int,int);

//--->Gestion
void CopySquareMatrix(float**,float**,int);
void copy_matrix(float**,float**,int,int); 

//--->Utile
float   Signe(float);
float   ComputeNorm2(float**,float**,int,int);
float   ComputeNorm2(float**,int,int);






